// RendDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "RendDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CRendDlg dialog
CRendDlg::CRendDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRendDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRendDlg)
	m_OKSens = FALSE;
	m_OKEffic = FALSE;
	m_OKRend = FALSE;
	//}}AFX_DATA_INIT
}
void CRendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRendDlg)
	DDX_Check(pDX, IDC_REND1, m_OKSens);
	DDX_Check(pDX, IDC_REND2, m_OKEffic);
	DDX_Check(pDX, IDC_REND3, m_OKRend);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CRendDlg, CDialog)
	//{{AFX_MSG_MAP(CRendDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CRendDlg message handlers
BOOL CRendDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_OKSens=TRUE;
	m_OKEffic=TRUE;
	m_OKRend=TRUE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CRendDlg::OnOK() 
{
	short i;
	float lambda;                        
	i=IDYES;
	if (m_pDoc->m_iNb!=0)
	{
		i=AfxMessageBox("Cette opration efface toutes les donnes en mmoire.\nContinuer ?",MB_YESNO);
	}	
	if (i==IDYES)
	{
		i=0;
		for (lambda=350.0;lambda<=1050.0;lambda=(float)(lambda+1.400))
		{
			m_pDoc->m_fT[i][0]=lambda;
			m_pDoc->m_fT[i][1]=m_pDoc->Sensibilite(lambda);
			m_pDoc->m_fT[i][2]=m_pDoc->Efficacite(lambda);
			m_pDoc->m_fT[i][3]=m_pDoc->Efficacite(lambda)*m_pDoc->Sensibilite(lambda);
			i++;
		}   
		m_pDoc->m_iNb=i; 
		UpdateData(TRUE);  
		m_pDoc->m_radioTypeAcq=4;
		m_pDoc->m_iTypeGr=0;
		if (m_OKSens) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1;
		if (m_OKEffic) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2;
		if (m_OKRend) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4;
		//Si rien n'a t slectionn, on slectionne tout!
		if (m_pDoc->m_iTypeGr==0) m_pDoc->m_iTypeGr=7;
		m_pDoc->UpdateAllViews(NULL);
	}
	CDialog::OnOK();
}
