// SerieDlg.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "SerieDlg.h"
#include "BkDoc.h"
#include "Chromex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CSerieDlg dialog
CSerieDlg::CSerieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerieDlg)
	m_s = _T("");
	m_radioPort = -1;
	//}}AFX_DATA_INIT
}
void CSerieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerieDlg)
	DDX_Control(pDX, IDCONNECTER, m_btnConnecter);
	DDX_Text(pDX, IDC_STATIC_TEST, m_s);
	DDX_Radio(pDX, IDC_COM1, m_radioPort);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSerieDlg, CDialog)
	//{{AFX_MSG_MAP(CSerieDlg)
	ON_BN_CLICKED(IDCONNECTER, OnConnecter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CSerieDlg message handlers
void CSerieDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CSerieDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_pDoc=m_pApp->GetDocument();
	m_radioPort=m_pApp->m_radioPort;
	if (!m_pApp->m_OKConnect)
	{
		m_s="Cliquez sur Connecter pour couter le port srie...";
		m_btnConnecter.SetWindowText("&Connecter...");
		GetDlgItem(IDC_COM1)->EnableWindow(TRUE);
		GetDlgItem(IDC_COM2)->EnableWindow(TRUE);
	}
	else
	{
		m_s.Format("Le port srie n%d est actuellement en connexion...",m_radioPort+1);
		m_btnConnecter.SetWindowText("&Dconnecter");
		GetDlgItem(IDC_COM1)->EnableWindow(FALSE);
		GetDlgItem(IDC_COM2)->EnableWindow(FALSE);
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CSerieDlg::OnConnecter() 
{
	UpdateData(TRUE);
	if (m_pApp->m_OKConnect)
	{
		m_s="Cliquez sur Connecter pour couter le port srie..";
		m_btnConnecter.SetWindowText("&Connecter");
		GetDlgItem(IDC_COM1)->EnableWindow(TRUE);
		GetDlgItem(IDC_COM2)->EnableWindow(TRUE);
		delete m_pApp->m_pChro;m_pApp->m_pChro=NULL;
	}
	else
	{
		m_s.Format("Le port srie n%d est maintenant en connexion. Vous pouvez Fermer...\n\nAUCUN CARACTERE n'est reu, c'est normal !\nFaire: Port srie/Tester communication...",m_radioPort+1);
		m_btnConnecter.SetWindowText("&Dconnecter");
		GetDlgItem(IDC_COM1)->EnableWindow(FALSE);
		GetDlgItem(IDC_COM2)->EnableWindow(FALSE);
		m_pApp->m_pChro=new CChromex(m_radioPort);
	}
	UpdateData(FALSE);
	m_pApp->m_OKConnect=!m_pApp->m_OKConnect;
}
//________________________________________
void CSerieDlg::OnCancel() 
{
	GetDlgItem(IDC_COM1)->EnableWindow(TRUE);
	GetDlgItem(IDC_COM2)->EnableWindow(TRUE);
	UpdateData(TRUE);
	m_pApp->m_radioPort=m_radioPort;
	CDialog::OnCancel();
}
