// Eurosmart.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "Eurosmart.h"
#include "DlPortIO.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CEurosmartDX
CEurosmart::CEurosmart()
{
	ADR1		=0x330;          
	ADR2		=0x340;          
	IOIN    =ADR2;
	IOOUT   =ADR2;
	MULPLEX =ADR2+1;
	COUNT0  =ADR1;
	COUNT1  =ADR1+1;
	COUNT2  =ADR1+2;
	TIMER   =ADR1+3;
	ADHIGH  =ADR1+4;
	ADLOW   =ADR1+5;
	STARTAD =ADR1+6;
	UPDDA   =ADR1+7;
	DA1LOW  =ADR1+4;
	DA1HIGH =ADR1+5;
	DA2LOW  =ADR1+6;
	DA2HIGH =ADR1+7;

	multies_current_polar=0;
	multies_current_chanel=0;

	if (GetVersion() & 0x80000000)
	{
		//W98, pas de connexion  PortIO
		m_OKConnect=TRUE;
	}
	else
	{
		//Connexion PortIO, n'existe pas, mais pour compatibilit avec DriverX
		m_OKConnect=TRUE;
	}
	//Test prsence carte
	float r;
	if(m_OKConnect)
	{
		int i;
		if (GetVersion() & 0x80000000)
		{
			//W98
			m_OKCarte=TRUE;//Important, mettre  TRUE, sinon LitTension saute !
			if (LitTension(0,0,1)==1e10)
				m_OKCarte=FALSE;
			else
				m_OKCarte=TRUE;
		}
		else
		{
			//W2000/XP : LitTension envoie toujours une valeur...
			i=readad();
			//CString z;z.Format("%d",i);AfxMessageBox(z);
			if (i==9999)
			{
				/*
				if (AfxMessageBox("Si la carte Eurosmart est prsente, installer\nsous une session ADMINISTRATEUR le logiciel :\nPort I/O Driver (port95nt.exe) ...\n\nDsirez-vous le tlcharger ?",MB_YESNO)==IDYES)
				{
					CString s="C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE";
					CString s1="http://gop.mermoz.free.fr/visuim/port95nt.exe";
					HINSTANCE er;
					short er1;
					er=ShellExecute(NULL,"open",s,s1,"",SW_SHOWMAXIMIZED);
					er1=(short)er;
					if (er1<=32)
					AfxMessageBox("Le logiciel est disponible sous :\nhttp://gop.mermoz.free.fr/visuim"); 
				}
				*/
				//m_OKConnect=FALSE;
				m_OKCarte=FALSE;
			}
			else
				m_OKCarte=TRUE;
		}
	}
	else
		m_OKCarte=FALSE;
}
//________________________________________
CEurosmart::~CEurosmart()
{
}
//________________________________________
BEGIN_MESSAGE_MAP(CEurosmart, CWnd)
	//{{AFX_MSG_MAP(CEurosmart)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CEurosmart message handlers
BOOL CEurosmart::Connect(void)
{
	//Sous PortIO m_OKConnect identique  m_OKCarte...
	return m_OKConnect;
}
//________________________________________
BOOL CEurosmart::OKCarte(void)
{
	return m_OKCarte;
}
//________________________________________
void CEurosmart::out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp(a,c);
	}
	else
	{
		//PortIO pour XP
	  DlPortWritePortUchar(a,c);
	}
}
//________________________________________
unsigned char CEurosmart::in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp(a);
	}
	else
	{
		//PortIO pour XP
	  k=DlPortReadPortUchar(a);
	}
	return k;
}
//________________________________________
float CEurosmart::LitTension(int NoVoie,char Type,int Nb)
{
	int nb,i,j;
	float u; 

	if (m_OKCarte)
	{
		nb=0;u=(float)0;
		switch (Type)
		{
			case 0://Unipolaire      
				setpolar('U');
				setchanel(NoVoie);// [0..7]
				for (j=1;j<=Nb;j++)
				{
					i=readad();
					if (i!=9999)
					{
						nb++;
						u=u+(float)(10.24*i/4095);
					}
				}
			break;
			case 1://Bipolaire
				setpolar('B');
				setchanel(NoVoie);// [0..7]
				for (j=1;j<=Nb;j++)
				{
					i=readad();
					if (i!=9999)
					{
						nb++;
						u=u+(float)((10.24*i/4095)-5.12);
					}
				}
			break;
		}
		if (nb!=0)
			u=u/nb;
		else
			u=(float)(1e10);
	}
	else
		u=1e10;
	return u;
}
//________________________________________
void CEurosmart::Sort_U(char NoVoie,float u)
{
	unsigned int i;
	if (m_OKCarte)
	{
		switch (NoVoie)
		{
			case 0:
				setpolar('U');
				i=(int)((u/10.24)*4095);
				setda1(i);
			break;
			case 1:
				setpolar('U');
				i=(int)((u/10.24)*4095);
				setda2(i);
			break;
			case 2:
				setpolar('B');
				i=(int)(2048-(u/10.24)*2048);
				setda2(i);
			break;
		}
	}
}
//________________________________________
//Fonctions originales Eurosmart
void CEurosmart::setpolar(char pol)
{
  if ((toupper(pol)=='U') || (toupper(pol)=='B'))
	{
  	if (toupper(pol) == 'U') multies_current_polar=1; else multies_current_polar=0;
  	out_port(MULPLEX,(multies_current_chanel << 1) | multies_current_polar);
  }
}
//________________________________________
void CEurosmart::setchanel(int ch)
{
  if ((ch >= 0) && (ch <= 7))
	{
		multies_current_chanel=ch;
  	out_port(MULPLEX,(multies_current_chanel<< 1) | multies_current_polar);
	}
}
//________________________________________
int CEurosmart::readad(void)
{
	int res,n=0;
  
	(void)in_port(STARTAD);             
	for (res=0;res<100;res++)
	{
		//On attend: important sur machines rapides
		;
	} 
	while ((in_port(ADHIGH) & 0x80)&&n<2000)
	{
		n++;
	}  
	if (n<2000)
	{
		for (res=0;res<100;res++) ;//On attend...
		res = ((in_port(ADHIGH) & 0x0F) << 8) + in_port(ADLOW);
		return res;
	}
	else
	{
		return 9999;
	}
}	                            
//________________________________________
void CEurosmart::initdrvad(void)
{
  outputio(0);
  setda1(0);
  setda2(0);
  setpolar('U');
  setchanel(0);
}
//________________________________________
void CEurosmart::outputio(unsigned char value)
{
	out_port(IOOUT,(multies_current_out = value));
} 
//________________________________________
void CEurosmart::setda1(unsigned int value)
{
	multies_update_da((multies_current_da1 = value), multies_current_da2);
}
//________________________________________
void CEurosmart::setda2(unsigned int value)
{
	multies_update_da(multies_current_da1, (multies_current_da2 = value));
}
//________________________________________
void CEurosmart::multies_update_da(unsigned int da1, unsigned int da2)
{
	out_port(DA1LOW, da1 & 0x00FF);
	out_port(DA1HIGH, da1 >> 8);
	out_port(DA2LOW, da2 & 0x00FF);
	out_port(DA2HIGH, da2 >> 8);
	(void) in_port(UPDDA);
}
