// CalbDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CalbDlg.h"
#include "chromex.h"
#include "conrsdlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CCalbDlg dialog
CCalbDlg::CCalbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCalbDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalbDlg)
	m_s1 = _T("");
	m_sLambda = _T("");
	//}}AFX_DATA_INIT
}
void CCalbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalbDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_LAMBDA, m_sLambda);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCalbDlg, CDialog)
	//{{AFX_MSG_MAP(CCalbDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CCalbDlg message handlers
BOOL CCalbDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	BOOL ok;
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	
	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	if (ok)
	{
		m_iNb=0;SetTimer(1,50,NULL);
	}
	return TRUE;
}
//________________________________________
void CCalbDlg::OnOK() 
{
	BOOL ok=TRUE;
	CString s;
	short i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sLambda,"%f",&r);
	if (i==1)
	{
		if (r<300) r=300;
		if (r>1100) r=1100;
	}
	else
		r=632.8;

	s.Format("Vous souhaitez que la long. d'onde de %1.2f nm\ncorresponde en ralit  %1.2f nm.\nEst-ce bien exact ?",m_fL,r);
	if (AfxMessageBox(s,MB_YESNO)==IDYES)
	{
		if (fabs(r-m_fL)>5)
		{
			s.Format("La dcalibration de %1.2f nm parat excessive !\nSouhaitez-vous faire cette calibration ?\nRpondez par Non en cas de doute et appelez un professeur...",fabs(r-m_fL));
			if (AfxMessageBox(s,MB_YESNO)==IDYES)
			{
				//Calibration
				ok=m_pApp->m_pChro->CG(r);
			}
		}
		else
			//Calibration
			ok=m_pApp->m_pChro->CG(r);
		if (!ok) AfxMessageBox("Erreur calibration !");
	}
	CDialog::OnOK();
}
//________________________________________
void CCalbDlg::OnCancel() 
{
	
	CDialog::OnCancel();
}
//________________________________________
void CCalbDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok;
	short 
		NbMax=20,
		i,k,l;
	float u,r;
	switch (nIDEvent)
	{
		//Paramtres du monochromateur: QM
		case 1://QM (4.36)
			m_iNb++;
			if (m_iNb>NbMax)
			{
				KillTimer(1);
				m_fL=m_pApp->m_pChro->QW();
				m_pApp->m_pChro->VideTampon();
				if (m_fL!=1e10)
				{
					m_s1.Format("Le monochromateur est positionn\nsur %1.2f nm.",m_fL);
					m_pApp->m_pChro->VideTampon();
					m_sLambda.Format("%1.2f",m_fL);
				}
				else
				{
					m_s1.Format("?");
					m_btnOK.EnableWindow(FALSE);
				}
				UpdateData(FALSE);
			}
		break;
	}	
	CDialog::OnTimer(nIDEvent);
}
