// ConRsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "ConRsDlg.h"
#include "BkView.h"
#include "BkDoc.h"
#include "Chromex.h"
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CConRsDlg dialog
CConRsDlg::CConRsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConRsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConRsDlg)
	m_sTexte1 = _T("");
	m_sTexte2 = _T("");
	//}}AFX_DATA_INIT
	Create(IDD_CONNEXION,pParent);
}
void CConRsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConRsDlg)
	DDX_Text(pDX, IDC_STATIC1, m_sTexte1);
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CConRsDlg, CDialog)
	//{{AFX_MSG_MAP(CConRsDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_VIDER, OnVider)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
//CConRsDlg message handlers
/*
void CConRsDlg::PostNcDestroy()
{
	//delete this;
}
*/
//__________________________________________________
BOOL CConRsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//Tampon de rception des donnes sur le port srie
	m_iNbCMax=1000;
	m_sBuf=new char[m_iNbCMax];
	m_sBuf[0]='\0';

	setlocale(LC_TIME,"French");
	m_pApp=(CBkApp*)AfxGetApp();
	m_pDoc=m_pApp->GetDocument();
	//m_OK=FALSE;
	m_sTexte2.Format("");
	m_sTexte1="";
	UpdateData(FALSE);	
	return TRUE;
}
//__________________________________________________
void CConRsDlg::Fermer(void)
{
	delete[] m_sBuf;
	KillTimer(99);
	CloseHandle(m_hCom);
	CDialog::OnCancel();
}
//__________________________________________________
void CConRsDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok=FALSE;

	if (nIDEvent==99)
	{
		//#define VC_EXTRALEAN		//A inhiber dans StdAfx.h
		if (WaitCommEvent(m_hCom,&dwEvtMask,&o))
		{
			if (dwEvtMask & EV_RXCHAR) 	
			{
				ok=ReadCom();
			}
			if (dwEvtMask & EV_RXFLAG) 	
			{
				//?
			}
		}

		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1;
		s=t.Format("%H:%M:%S");
		m_sTexte2.Format("Connect  COM%d:9600,8,'N',1 depuis %s\nLe tampon contient %d caractre(s).",m_radioCom+1,s,strlen(m_sBuf));

		if (ok)
		{
			//On attend d'autres caractres ventuels...
			//Pas ncessaire ici, a vient d'un coup
			//KillTimer(99);
			//m_iNb=0;
			//SetTimer(98,10,NULL);
		}
	}	
	if (nIDEvent==98)
	{
		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1;
		s=t.Format("%H:%M:%S");
		m_sTexte2.Format("Connect  COM%d:9600,8,'N',1 depuis %s\n(*) Le tampon contient %d caractre(s).",m_radioCom+1,s,strlen(m_sBuf));
				
		m_iNb++;
		if (m_iNb>5)
		{
			KillTimer(98);
			SetTimer(99,10,NULL);
			//Fin de l'acquisition
			//m_pApp->m_OKAcq=FALSE;
		}
		else
		{
			ok=ReadCom();
			if (ok)
			{
				m_iNb=0;
			}
		}
	}
	
	if (ok)
	{
		if (strlen(m_sBuf)>=m_iNbCMax)
		{
			m_sBuf[0]='\0';
			m_sTexte2.Format("Initialisation tampon ...");
			UpdateData(FALSE);
			Sleep(800); 
		}
		if (m_sTexte1.GetLength()>115)
		{
			s="... "+m_sTexte1.Right(115-1);
			m_sTexte1=s;
		}
	}
	UpdateData(FALSE);	
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
HANDLE CConRsDlg::Connexion(int radioCom) 
{
	DCB dcb;
	BOOL ok;

	m_radioCom=radioCom;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{		
		GetCommState(m_hCom,&dcb);
		//Paramtres du port srie
		//9600,8,'P',1
		//dcb.DCBlength=48;			//sizeof(DCB)
		dcb.fOutxCtsFlow=0;			//CTS
		dcb.fOutxDsrFlow=0;			//DSR
		dcb.fDtrControl=DTR_CONTROL_ENABLE;
		dcb.fDsrSensitivity=1;
		dcb.BaudRate=CBR_9600;	//9600 bauds
		dcb.fParity=1;					//Enable parity checking
		dcb.fTXContinueOnXoff=1;
		dcb.fOutX=1;						//Protocole XON/XOFF
		dcb.fInX=1;
		dcb.fErrorChar=0;//1;
		dcb.fNull=0;//1;
		dcb.fRtsControl=0;			//RTS_CONTROL_HANDSHAKE
		dcb.fAbortOnError=1;
		dcb.fDummy2=0;//17;
		dcb.XonLim=2048;
		dcb.XoffLim=512;
		dcb.ByteSize=8;					//8 bits
		dcb.Parity=0;						//0:no, 1:odd, 2:even, 3:mark, 4:space
		dcb.StopBits=ONESTOPBIT;//1 bit stop
		dcb.XonChar=17;
		dcb.XoffChar=19;
		dcb.ErrorChar=0;
		dcb.EofChar='_';				//Non dfini
		dcb.EvtChar='_';				//Non dfini
		dcb.fBinary=1;					//Obligatoirement TRUE
		//Dans StdAfx.h:
		//#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers
		SetCommState(m_hCom,&dcb);
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=1;
			ctmo.ReadTotalTimeoutMultiplier=1;
			ctmo.ReadTotalTimeoutConstant=1;
			ctmo.WriteTotalTimeoutConstant=1;
			ctmo.WriteTotalTimeoutMultiplier=1;
			SetCommTimeouts(m_hCom,&ctmo);
		}
		//Set the event mask
		ok=SetCommMask(m_hCom,EV_RXCHAR /*| EV_RXFLAG*/);
		if (!ok) 
		{
			//Deal with error
			AfxMessageBox("Erreur !!");
		}
		//Create an event object for use in WaitCommEvent
		o.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
		m_t1=CTime::GetCurrentTime();   
		SetTimer(99,10,NULL);
	}
	return m_hCom;
}
//__________________________________________________
BOOL CConRsDlg::ReadCom(void)
{
	//Les caractres retourns sont dans le buffer m_sBuf
	BOOL ok;
	DWORD i,j;
	short nb;
	char c[121];

	ok=ReadFile(m_hCom,c,120,&j,NULL);
	i=0;
	if (ok && j!=0)
	{
		//Nb. de caractres lus: j
		if (j+strlen(m_sBuf)>=m_iNbCMax)
		{
			//On fait de la place dans la buffer
			m_sBuf[m_iNbCMax-j-1]='\0';
			//m_sTexte2.Format("Vidage tampon ...");
			//UpdateData(FALSE);
			//Sleep(800); 
		}
		for (i=0;i<j;i++)
		{
			nb=strlen(m_sBuf);
			m_sBuf[nb]=c[i];
			m_sBuf[nb+1]='\0';

			if (c[i]!='\r')
				 m_sTexte1=m_sTexte1+c[i];
			else
				 m_sTexte1=m_sTexte1+", ";
		}
	}
	if (i>0) return TRUE; else return FALSE;
}
//__________________________________________________
void CConRsDlg::OnVider() 
{
	m_sBuf[0]='\0';
	m_sTexte2.Format("Initialisation tampon ...");
	m_sTexte1="";
	UpdateData(FALSE);
	Sleep(800); 
}
//__________________________________________________
char CConRsDlg::IsChar(CString m) 
{
	BOOL ok=FALSE;
	DWORD i,j;
	char 
		*pdest,
		c1,
		c=-1,
		s1[11];

	ok=ReadFile(m_hCom,s1,10,&j,NULL);
	if (ok && j!=0) 
	{
		s1[j]='\0';
		for (i=0;i<m.GetLength();i++)
		{
			//Caractre  trouver...
			c1=m.GetAt(i);
			pdest=strrchr(s1,c1);
			if (pdest!=NULL)
			{
				c=c1;
			}
		}
	}
	return c;
}
