// PilotDlg.h : header file
//________________________________________
// CPilotDlg dialog
class CPilotDlg : public CDialog
{
// Construction
public:
	CPilotDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CPilotDlg)
	enum { IDD = IDD_PILOTAGE };
	CButton	m_btnFenteS;
	CButton	m_btnFenteE;
	CButton	m_btnCalibrer;
	CButton	m_btnLambda;
	CButton	m_btnCancel;
	CButton	m_btnStepUp;
	CButton	m_btnStepDown;
	CStatic	m_s2;
	CString	m_sL;
	CString	m_sFS;
	CString	m_sFE;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPilotDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc* m_pDoc;	
	class CBkApp* m_pApp;
	class	CCandibus* m_pCandi;
	class	CEurosmart* m_pEuro;

	short	
		m_iFE,
		m_iFS;
	float
		m_fL;
	short
		m_iNb,
		m_iNo;
	
	void Valider(void);
	void Invalider(void);

	// Generated message map functions
	//{{AFX_MSG(CPilotDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLambd();
	afx_msg void OnStepup();
	afx_msg void OnStepdown();
	afx_msg void OnCalibrer();
	afx_msg void OnRegFenteE();
	afx_msg void OnRegFenteS();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
