// SiAcqDlg.h : header file
//________________________________________
// CSiAcqDlg dialog
class CSiAcqDlg : public CDialog
{
// Construction
public:
	CSiAcqDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSiAcqDlg)
	enum { IDD = IDD_SIGMA_ACQ };
	CProgressCtrl	m_progress;
	CButton	m_btnCancel;
	CButton	m_btnDemarrer;
	CButton	m_btnArreter;
	CString	m_s;
	CString	m_sSigma1;
	CString	m_sSigma2;
	CString	m_sPasSigma;
	CString	m_sLambda1;
	CString	m_sLambda2;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSiAcqDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc *m_pDoc;	
	class CBkApp* m_pApp;
	class CCandibus *m_pCandi;
	class CEurosmart *m_pEuro;
	short
		m_iFS,m_iFE,
		m_iDuree,
		m_iNb,
		m_iNo,
		m_iNbA;
	
	float
		m_fL,
		m_fSigma1,m_fSigma2,m_fPasSigma;
	
	void VerifPara();
	void Valider(void);
	void Invalider(void);
	void AffecteZ();
	void AffecteV();

	// Generated message map functions
	//{{AFX_MSG(CSiAcqDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDemarrer();
	afx_msg void OnArreter();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnChangeSigma1();
	afx_msg void OnChangeSigma2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
