// AnDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "AnDlg.h"
#include "CandibusDX.h"
#include "EurosmartDX.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAnDlg dialog
CAnDlg::CAnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnDlg)
	m_s = _T("");
	m_radioMoy = -1;
	m_radioVoie = -1;
	m_radioTypeAcq = -1;
	//}}AFX_DATA_INIT
}
void CAnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnDlg)
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Text(pDX, IDC_STATIC1, m_s);
	DDX_Radio(pDX, IDC_MOY1, m_radioMoy);
	DDX_Radio(pDX, IDC_VOIE0, m_radioVoie);
	DDX_Radio(pDX, IDC_TYPEACQ, m_radioTypeAcq);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAnDlg, CDialog)
	//{{AFX_MSG_MAP(CAnDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CAnDlg message handlers
BOOL CAnDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_radioVoie=m_pApp->m_radioVoie;
	m_radioMoy=m_pApp->m_radioMoy;
	m_radioTypeAcq=m_pApp->m_radioTypeAcq;
	m_pCandi=new CCandibusDX();
	m_pEuro=new CEurosmartDX();
	m_s="U(V): ?";
	UpdateData(FALSE);
	switch (m_pApp->m_iTypeCarte)
	{
		case 0://Eurosmart
			//Tout est valide
		break;
		case 1://Candibus
			GetDlgItem(IDC_TYPEACQ)->EnableWindow(FALSE);
			GetDlgItem(IDC_TYPEACQ1)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE3)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE4)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE5)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE6)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE7)->EnableWindow(FALSE);
		break;
		default://Aucune
			//Rien n'est valide
			m_btnTest.EnableWindow(FALSE);
			GetDlgItem(IDC_MOY1)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY2)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY4)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY8)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY16)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY32)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY64)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY128)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY256)->EnableWindow(FALSE);
			GetDlgItem(IDC_MOY512)->EnableWindow(FALSE);
			GetDlgItem(IDC_TYPEACQ)->EnableWindow(FALSE);
			GetDlgItem(IDC_TYPEACQ1)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE0)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE1)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE2)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE3)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE4)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE5)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE6)->EnableWindow(FALSE);
			GetDlgItem(IDC_VOIE7)->EnableWindow(FALSE);
		break;		
	}
	m_OK=TRUE;
	return TRUE;
}
//________________________________________
void CAnDlg::OnTest() 
{
	UpdateData(TRUE);
	GetDlgItem(IDC_VOIE0)->EnableWindow(!m_OK);
	GetDlgItem(IDC_VOIE1)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY1)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY2)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY4)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY8)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY16)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY32)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY64)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY128)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY256)->EnableWindow(!m_OK);
	GetDlgItem(IDC_MOY512)->EnableWindow(!m_OK);
	if (m_pApp->m_iTypeCarte==0)
	{
		//Eurosmart
		GetDlgItem(IDC_TYPEACQ)->EnableWindow(!m_OK);
		GetDlgItem(IDC_TYPEACQ1)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE2)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE3)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE4)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE5)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE6)->EnableWindow(!m_OK);
		GetDlgItem(IDC_VOIE7)->EnableWindow(!m_OK);
	}
	m_btnCancel.EnableWindow(!m_OK);
	if (m_OK)
	{
		m_btnTest.SetWindowText("Arrter");
		SetTimer(1,200,NULL);
	}
	else
	{
		KillTimer(1);
		m_btnTest.SetWindowText("Tester");
	}
	m_OK=!m_OK;
}
//________________________________________
void CAnDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CAnDlg::OnCancel() 
{
	UpdateData(TRUE);
	m_pApp->m_radioVoie=m_radioVoie;
	m_pApp->m_radioMoy=m_radioMoy;
	m_pApp->m_radioTypeAcq=m_radioTypeAcq;
	delete m_pCandi;
	delete m_pEuro;
	CDialog::OnCancel();
}
//________________________________________
void CAnDlg::OnTimer(UINT nIDEvent) 
{
	float u;
	short i,j;

	j=(short)(pow(2,m_radioMoy));
	switch (m_pApp->m_iTypeCarte)
	{
		case 0:
			//Eurosmart
			u=m_pEuro->LitTension(m_radioVoie,m_radioTypeAcq,j);
		break;
		case 1:
			//Candibus
			u=m_pCandi->LitTension(m_radioVoie,j);
		break;
		default:
			u=1e10;
		break;
	}
	if (u==1e10)
		m_s.Format("U(V): ?");
	else
		m_s.Format("U(V): %1.2f",u);
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
