// ChroDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ChroDlg.h"
#include "BkDoc.h"
#include "Chromex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CChroDlg dialog
CChroDlg::CChroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChroDlg)
	m_radioCom = -1;
	m_s = _T("");
	m_s3 = _T("");
	m_s1 = _T("");
	m_sCde = _T("");
	//}}AFX_DATA_INIT
}
void CChroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChroDlg)
	DDX_Radio(pDX, IDC_COM1, m_radioCom);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	DDX_Text(pDX, IDC_STATIC1, m_s3);
	DDX_Text(pDX, IDC_STATIC_TEXTE2, m_s1);
	DDX_Text(pDX, IDC_CDE, m_sCde);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CChroDlg, CDialog)
	//{{AFX_MSG_MAP(CChroDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDENVOYER, OnEnvoyer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CChroDlg message handlers
void CChroDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
BOOL CChroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_radioCom=m_pApp->m_radioCom;
	m_pChro=new CChromex(m_radioCom);
	m_s="Slectionner le n du port,";
	m_s1="puis cliquer sur Tester";
	m_sCde="QE/n";
	UpdateData(FALSE);
	return TRUE;
}
//__________________________________________________
void CChroDlg::OnTest() 
{
	UpdateData(TRUE);
	BOOL ok;
	if (m_radioCom!=m_pApp->m_radioCom)
	{
		delete m_pChro;
		m_pChro=new CChromex(m_radioCom);
		m_pApp->m_radioCom=m_radioCom;
	}
	//Demande de longueur d'onde courante
	ok=m_pChro->WriteCom("QW/n\r");
	if (ok)
	{
		m_iNb=0;
		//Attente de la long. d'onde
		SetTimer(1,1,NULL);
	}
}
//__________________________________________________
void CChroDlg::OnCancel() 
{
	delete m_pChro;
	UpdateData(TRUE);
	m_pApp->m_radioCom=m_radioCom;
	CDialog::OnCancel();
}
//__________________________________________________
void CChroDlg::OnTimer(UINT nIDEvent) 
{
	BOOL ok;
	short NbMax=10;
	switch (nIDEvent)
	{
		case 1://QW
			m_iNb++;
			m_fL=m_pChro->AnalyseTampon();
			if (m_fL!=1e10 )
			{
				KillTimer(1);
				m_s.Format("Lambda courant (nm): %1.2f",m_fL);
				m_s1="";
			}
			if (m_iNb>=NbMax)
			{
				KillTimer(1);
				m_s.Format ("Erreur de communication !");
				m_s1="";
			}
		break;
	}
	m_s3.Format("(%d)",m_iNb);
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CChroDlg::OnEnvoyer() 
{
	CString s;
	UpdateData(TRUE);
	m_sCde.MakeUpper();
	UpdateData(FALSE);
	s.Format("%s\r",m_sCde);
	m_pChro->WriteCom(s);
}
