// Chromex.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "Chromex.h"
#include "ConRsDlg.h"
#include <sys/timeb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CChromex
CChromex::CChromex(short iNoCom)
{
	m_pApp=(CBkApp*)AfxGetApp();
	m_pConRsDlg=new CConRsDlg();
	hCom=m_pConRsDlg->Connexion(iNoCom);
}
//________________________________________
CChromex::~CChromex()
{
	//Positionner les fentes  2000 m -> Modifi le 15/01/04
	//AB(2000);
	m_pConRsDlg->Fermer();
	delete m_pConRsDlg;
}
BEGIN_MESSAGE_MAP(CChromex, CStatic)
	//{{AFX_MSG_MAP(CChromex)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CChromex message handlers
BOOL CChromex::WriteCom(CString s)
{
	BOOL ok;
	DWORD i;
	short k;
	ok=WriteFile(hCom,s,s.GetLength(),&i,NULL);
	if (!ok || i!=s.GetLength())
	{
		ok=FALSE;
	}
	
	return ok;
}
//Extraction donne numrique  la fin____
float CChromex::AnalyseTampon(void)
{
	char 
		c,
		s1[11]="          ",
		s[11]= "          ";
	short m,n,p,i;
	float l;
	char *pdest;
	//Analyse du buffer
	//p=m_sBuf.ReverseFind('\r');
	pdest=strrchr(m_pConRsDlg->m_sBuf,'\r');
	if (pdest!=NULL)
	{
		p=pdest-m_pConRsDlg->m_sBuf+1;
		p=p-1;//On se place sur le dernier car. numrique
		n=p;
		m=0;
		do
		{
			c=m_pConRsDlg->m_sBuf[n];
			if (m<10 && (c=='.' || isdigit(c)))
			{
				s[m]=c;;
				m++;
				s[m]='\0';
			}
			n--;
		}
		while (n>=0 && c!='\r' && c!='\n');
		//Inversion de s dans s1
		m=0;
		for (n=strlen(s)-1;n>=0;n--)
		{
			c=s[n];
			s1[m]=c;
			m++;
			s1[m]='\0';
		}
		i=sscanf(s1,"%f",&l);
		if (i==0) 
			l=1e10;
		else
		{	
			//On vide le buffer
			m_pConRsDlg->m_sBuf[0]='\0';
		}
	}
	else
		l=1e10;
	return l;
}
//________________________________________
void CChromex::VideTampon(void)
{
	m_pConRsDlg->m_sBuf[0]='\0';
}
//________________________________________
short CChromex::QX(void)
{
	short
		l,
		p,i,j;
	char 
		c,
		s[20],
		*pdest;

	CString m="Current Exit Slit Width";

	pdest=strstr(m_pConRsDlg->m_sBuf,m);
	if (pdest!=NULL)
	{
		p=pdest-m_pConRsDlg->m_sBuf+1;
		p=p+m.GetLength();
		//Recherche du 'u' de um
		i=0;
		do
		{
			c=m_pConRsDlg->m_sBuf[p];
			if (isdigit(c) || c=='.')
			{
				s[i]=c;
				i++;
				s[i]='\0';
			}
			p++;
		}
		while ((p<strlen(m_pConRsDlg->m_sBuf)) && c!='u');
		if (i!=0)
		{
			//Extraction
			j=sscanf(s,"%d",&l);
			if (j==0)
			{
				l=-1;
			}
		}
	}
 return l;
} 
//________________________________________
short CChromex::QE(void)
{
	short
		l,
		p,i,j;
	char 
		c,
		s[20],
		*pdest;

	CString m="Current Entrance Slit Width";

	pdest=strstr(m_pConRsDlg->m_sBuf,m);
	if (pdest!=NULL)
	{
		p=pdest-m_pConRsDlg->m_sBuf+1;
		p=p+m.GetLength();
		//Recherche du 'u' de um
		i=0;
		do
		{
			c=m_pConRsDlg->m_sBuf[p];
			if (isdigit(c) || c=='.')
			{
				s[i]=c;
				i++;
				s[i]='\0';
			}
			p++;
		}
		while ((p<strlen(m_pConRsDlg->m_sBuf)) && c!='u');
		if (i!=0)
		{
			//Extraction
			j=sscanf(s,"%d",&l);
			if (j==0)
			{
				l=-1;
			}
		}
	}
 return l;
} 
//________________________________________
float CChromex::QW(void)
{
	short	p,i,j;
	float r;
	char 
		c,
		s[20],
		*pdest;

	CString m="Current Wavelength";

	pdest=strstr(m_pConRsDlg->m_sBuf,m);
	if (pdest!=NULL)
	{
		p=pdest-m_pConRsDlg->m_sBuf+1;
		p=p+m.GetLength();
		//Recherche du 'n' de nm
		i=0;
		do
		{
			c=m_pConRsDlg->m_sBuf[p];
			if (isdigit(c) || c=='.')
			{
				s[i]=c;
				i++;
				s[i]='\0';
			}
			p++;
		}
		while ((p<strlen(m_pConRsDlg->m_sBuf)) && c!='n');
		if (i!=0)
		{
			//Extraction
			j=sscanf(s,"%f",&r);
			if (j==0)
			{
				r=1e10;
			}
		}
	}
 return r;
}
//________________________________________
BOOL CChromex::GW(float lambda)
{
	CString s;
	char c;
	BOOL ok; 
	CTimeSpan t;

	s.Format("GW%1.2f\r",lambda);
	ok=WriteCom(s);
	if (ok)
	{
		//Attente caractre d'tat

		m_t1=CTime::GetCurrentTime();
		do
		{
			c=m_pConRsDlg->IsChar("+-=");
			m_t2=CTime::GetCurrentTime();
			t=m_t2-m_t1;
		}
		while (c!='+' && c!='-' && c!='=' && t<5 );//Attente maxi 5 s
		//Dmarrage si pas dj sur cette longueur d'onde
		if (c=='+' || c=='-')
		{
			ok=WriteCom("!\r");
			//Attente caractre de fin de dplacement
			if (ok)
			{
				m_t1=CTime::GetCurrentTime();
				do
				{	
					c=m_pConRsDlg->IsChar("*");
					m_t2=CTime::GetCurrentTime();
					t=m_t2-m_t1;
				}
				while (c!='*' && t<15);//Attente maxi 15 s
				if (c=='*') ok=TRUE; else ok=FALSE; 
			}
		}
		else
		if (c=='=')
		{
			//On est dj positionn
			ok=TRUE;
		}
		else
			ok=FALSE;
	}
	return ok;
}
//________________________________________
BOOL CChromex::AE(short l)
{
	CString s;
	char c;
	BOOL ok;
	CTimeSpan t;
		
	s.Format("AE%d\r",l);
	ok=WriteCom(s);
	if (ok)
	{
		m_t1=CTime::GetCurrentTime();
		//Attente caractre d'tat
		do
		{
			c=m_pConRsDlg->IsChar(">=?");
			m_t2=CTime::GetCurrentTime();
			t=m_t2-m_t1;

		}
		while (c!='>' && c!='=' && c!='?' && t<3);//Attente au maxi 3 s !
		if (c=='=' && t<3)	ok=TRUE; else ok=FALSE;
	}
	return ok;
}
//________________________________________
BOOL CChromex::AX(short l)
{
	CString s;
	char c;
	BOOL ok;
	CTimeSpan t;

	s.Format("AX%d\r",l);
	ok=WriteCom(s);
	if (ok)
	{
		m_t1=CTime::GetCurrentTime();
		//Attente caractre d'tat
		do
		{
			c=m_pConRsDlg->IsChar(">=?");
			m_t2=CTime::GetCurrentTime();//millisecond
			t=m_t2-m_t1;
		}
		while (c!='>' && c!='=' && c!='?' && t<3);
		if (c=='=' && t<3)	ok=TRUE; else ok=FALSE;
	}
	return ok;
}
//________________________________________
BOOL CChromex::AB(short l)
{
	CString s;
	char c;
	BOOL ok;

	s.Format("AB%d\r",l);
	ok=WriteCom(s);
	if (ok)
	{
		//Attente caractre d'tat
		do
		{
			c=m_pConRsDlg->IsChar(">=?");
		}
		while (c!='>' && c!='=' && c!='?');
		if (c=='=')	ok=TRUE; else ok=FALSE;
	}
	return ok;
}
//________________________________________
BOOL CChromex::CG(float lambda)
{
	CString s;
	char c;
	BOOL ok;

	s.Format("CG%1.2f\r",lambda);
	ok=WriteCom(s);
	if (ok)
	{
		//Attente caractre d'tat
		do
		{
			c=m_pConRsDlg->IsChar(">=?");
		}
		while (c!='>' && c!='=' && c!='?');
		if (c=='=')	ok=TRUE; else ok=FALSE;
	}
	return ok;
}
