// LaAcqDlg.h : header file
//________________________________________
// CLaAcqDlg dialog
class CLaAcqDlg : public CDialog
{
// Construction
public:
	CLaAcqDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CLaAcqDlg)
	enum { IDD = IDD_LAMBDA_ACQ };
	CProgressCtrl	m_progress;
	CButton	m_btnDemarrer;
	CButton	m_btnCancel;
	CButton	m_btnArreter;
	CString	m_sLambda1;
	CString	m_sLambda2;
	CString	m_sPasLambda;
	CString	m_s;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLaAcqDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc *m_pDoc;	
	class CBkApp* m_pApp;
	class CCandibusDX *m_pCandi;
	class CEurosmartDX *m_pEuro;
	short
		m_iFS,m_iFE,
		m_iDuree,
		m_iNb,
		m_iNo,
		m_iNbA;
	float
		m_fL,
		m_fUMax,m_fLambdaMax,
		m_fLambda1,m_fLambda2,m_fPasLambda;
	
	void VerifPara();
	void Valider(void);
	void Invalider(void);
	void AffecteZ();
	void AffecteV();

	// Generated message map functions
	//{{AFX_MSG(CLaAcqDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDemarrer();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnArreter();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
