// TypAcDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "TypAcDlg.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CTypAcDlg dialog
CTypAcDlg::CTypAcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTypAcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTypAcDlg)
	m_radioTypeAcq = -1;
	//}}AFX_DATA_INIT
}
void CTypAcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTypAcDlg)
	DDX_Radio(pDX, IDC_RADIO_TYPE, m_radioTypeAcq);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTypAcDlg, CDialog)
	//{{AFX_MSG_MAP(CTypAcDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CTypAcDlg message handlers
BOOL CTypAcDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	//Si on tait dans rendement, on choisit U=f(lambda)
	if (m_pDoc->m_radioTypeAcq<4)
		m_radioTypeAcq=m_pDoc->m_radioTypeAcq;
	else
		m_radioTypeAcq=0;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTypAcDlg::OnOK() 
{
	UpdateData(TRUE);
	if (m_pDoc->m_radioTypeAcq!=m_radioTypeAcq)
	{
		//Un changement de type d'acquisition efface les mesures
		m_pDoc->m_iNb=0; 
		m_pDoc->UpdateAllViews(NULL);
	}
	m_pDoc->m_radioTypeAcq=m_radioTypeAcq; 
	CDialog::OnOK();
}
//________________________________________
