// ConRsDlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "ConRsDlg.h"
#include "BkView.h"
#include "BkDoc.h"
#include "Chromex.h"
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CConRsDlg dialog
CConRsDlg::CConRsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConRsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConRsDlg)
	m_sTexte1 = _T("");
	m_sTexte2 = _T("");
	//}}AFX_DATA_INIT
	Create(IDD_CONNEXION,pParent);
}
void CConRsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConRsDlg)
	DDX_Text(pDX, IDC_STATIC1, m_sTexte1);
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CConRsDlg, CDialog)
	//{{AFX_MSG_MAP(CConRsDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_VIDER, OnVider)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
//CConRsDlg message handlers
/*
void CConRsDlg::PostNcDestroy()
{
	//delete this;
}
*/
//________________________________________
BOOL CConRsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//Tampon de rception des donnes sur le port srie
	m_iNbCMax=1000;
	m_sBuf=new char[m_iNbCMax];
	m_sBuf[0]='\0';

	setlocale(LC_TIME,"French");
	m_pApp=(CBkApp*)AfxGetApp();
	m_pDoc=m_pApp->GetDocument();
	//m_OK=FALSE;
	m_sTexte2.Format("");
	m_sTexte1="";
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CConRsDlg::Fermer(void)
{
	delete[] m_sBuf;
	KillTimer(99);
	CloseHandle(m_hCom);
	CDialog::OnCancel();
}
//________________________________________
void CConRsDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok=FALSE;
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		ok=ReadCom();
		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1;
		s=t.Format("%H:%M:%S");
		m_sTexte2.Format("Connect  COM%d:9600,8,'N',1 depuis %s\nLe tampon contient %d caractre(s).",m_radioCom+1,s,strlen(m_sBuf));
		if (ok)
		{
			if (strlen(m_sBuf)>=m_iNbCMax)
			{
				m_sBuf[0]='\0';
				m_sTexte2.Format("Initialisation tampon ...");
				UpdateData(FALSE);
				Sleep(800); 
			}
			if (m_sTexte1.GetLength()>115)
			{
				s="... "+m_sTexte1.Right(115-1);
				m_sTexte1=s;
			}
		}
		m_OKBusy=FALSE;
	}
	UpdateData(FALSE);	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
HANDLE CConRsDlg::Connexion(int radioCom) 
{
	DCB dcb;
	BOOL ok;

	m_radioCom=radioCom;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{		
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=MAXDWORD;
			ctmo.ReadTotalTimeoutMultiplier=0;
			ctmo.ReadTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutMultiplier=0;
			SetCommTimeouts(m_hCom,&ctmo);
		}

		GetCommState(m_hCom,&dcb);
		//Paramtres du port srie pour Chromex
		//9600,8,'N',1
		CString s="96,n,8,1,x";
		ok=BuildCommDCB(s,&dcb);
		if (!ok) AfxMessageBox("Erreur fonction BuildCommDCB");
		SetCommState(m_hCom,&dcb);
		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
	}
	return m_hCom;
}
//________________________________________
BOOL CConRsDlg::ReadCom(void)
{
	//Les caractres retourns sont dans le buffer m_sBuf
	BOOL ok;
	DWORD i,j;
	short nb;
	char c[121];
	//                    1 ?
	ok=ReadFile(m_hCom,c,120,&j,NULL);
	i=0;
	if (ok && j!=0)
	{
		//Nb. de caractres lus: j
		if (j+strlen(m_sBuf)>=m_iNbCMax)
		{
			//On fait de la place dans la buffer
			m_sBuf[m_iNbCMax-j-1]='\0';
			//m_sTexte2.Format("Vidage tampon ...");
			//UpdateData(FALSE);
			//Sleep(800); 
		}
		for (i=0;i<j;i++)
		{
			nb=strlen(m_sBuf);
			m_sBuf[nb]=c[i];
			m_sBuf[nb+1]='\0';

			if (c[i]!='\r')
				 m_sTexte1=m_sTexte1+c[i];
			else
				 m_sTexte1=m_sTexte1+", ";
		}
	}
	if (i>0) return TRUE; else return FALSE;
}
//________________________________________
void CConRsDlg::OnVider() 
{
	m_sBuf[0]='\0';
	m_sTexte2.Format("Initialisation tampon ...");
	m_sTexte1="";
	UpdateData(FALSE);
	Sleep(800); 
}
//________________________________________
char CConRsDlg::IsChar(CString m) 
{
	BOOL ok=FALSE;
	DWORD i,j;
	char 
		*pdest,
		c1,
		c=-1,
		s1[11];

	ok=ReadFile(m_hCom,s1,10,&j,NULL);
	if (ok && j!=0) 
	{
		s1[j]='\0';
		for (i=0;i<m.GetLength();i++)
		{
			//Caractre  trouver...
			c1=m.GetAt(i);
			pdest=strrchr(s1,c1);
			if (pdest!=NULL)
			{
				c=c1;
			}
		}
	}
	return c;
}
