// TestDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "TestDlg.h"
#include "BkDoc.h"
#include "Chromex.h"
#include "ConRsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CTestDlg dialog
CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
	m_s0 = _T("");
	m_s1 = _T("");
	m_s2 = _T("");
	m_s3 = _T("");
	//}}AFX_DATA_INIT
}
void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_PROGRES, m_progress);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Text(pDX, IDC_STATIC_TEXTE0, m_s0);
	DDX_Text(pDX, IDC_STATIC_TEXTE1, m_s1);
	DDX_Text(pDX, IDC_STATIC_TEXTE2, m_s2);
	DDX_Text(pDX, IDC_STATIC_TEXTE3, m_s3);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CTestDlg message handlers
void CTestDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	
	m_iNbMax=25;
	m_progress.SetRange(0,m_iNbMax);
	m_s1="Cliquer sur Tester pour";
	m_s2="transmettre les paramtres courants...";
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CTestDlg::OnTest() 
{
	BOOL ok;

	m_pApp->m_pChro->VideTampon();

	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	if (ok)
	{
		m_btnTest.EnableWindow(FALSE);
		m_btnCancel.EnableWindow(FALSE);
		m_iNb=0;
		//Attente des paramtres
		SetTimer(1,50,NULL);
	}
}
//________________________________________
void CTestDlg::OnCancel() 
{
	//Libration console
	m_pApp->m_pChro->WriteCom("RL\r");
	CDialog::OnCancel();
}
//________________________________________
void CTestDlg::OnTimer(UINT nIDEvent) 
{
	float lambda;
	short fe,fs;
	switch (nIDEvent)
	{
		case 1://Tempo
			m_iNb++;
			if (m_iNb>=m_iNbMax)
			{
				KillTimer(1);
				lambda=m_pApp->m_pChro->QW();
				fe=m_pApp->m_pChro->QE();
				fs=m_pApp->m_pChro->QX();
				m_pApp->m_pChro->VideTampon();
				if (lambda!=1e10 && fe!=-1 && fs!=-1)
				{
					m_s1.Format("Lambda courant (nm): %1.2f",lambda);
					m_s2.Format("Larg. fente d'entre (m): %d",fe);
					m_s3.Format("Larg. fente de sortie (m): %d",fs);
					m_pApp->m_pChro->VideTampon();
				}
				
				else
				{
					m_s1.Format("Erreur de transmission");
					m_s2.Format("");
					m_s3.Format("");
				}
				m_btnTest.EnableWindow(TRUE);
				m_btnCancel.EnableWindow(TRUE);
				UpdateData(FALSE);
			}
		break;
	}
	m_progress.SetPos(m_iNb+1);
	//m_s0.Format("(%d)",m_iNb);
	//UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
